]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- 1.571: add %%pear_package_print_optionalpackages
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
4
5# can be used by builder script to check for version
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
8%epoch 0
9%x8664 x86_64 amd64 ia32e
10%arm armv3l armv4b armv4l armv5teb armv5tel
11
12# kernel compiler
13%kgcc %{__cc}
14%kgcc_package gcc
15
16# compiler version
17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
19
20%__rm /bin/rm --interactive=never
21
22# Build system path macros.
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
28#
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
31#
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
35%__cmake /usr/bin/cmake
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
39
40%__gettextize { \
41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
42 gettextize --copy --force --no-changelog; \
43 else \
44 gettextize --copy --force --no-changelog --intl; \
45 fi; \
46 if [ ! -f po/Makevars ]; then \
47 cp -f po/Makevars{.template,}; \
48 fi; \
49}
50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
53%__gnome_doc_prepare gnome-doc-prepare --copy --force
54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
56%__libtoolize libtoolize --copy --force --install
57
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
63 pwd
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
66 cd ..; pwd
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
72 cd ..; pwd
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
75 pwd
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
78 cd packages; pwd
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
84
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
96
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
100%dependencytracking %{nil}
101
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
122# %rpmldflags = %optldflags - %filterout_ld
123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
128 for (i = 1; i in I; i++) { A=0; \
129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
144 %{filter_out}
145}')
146
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
153%rpmldflags %(awk 'BEGIN {
154 split("%{?optldflags}",I);
155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
181# %define _preserve_env ADDITIONAL_VAR
182
183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
184
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
187 split("%{?_preserve_env}", P);
188 for (i in P) {
189 p = P[i];
190 if (!ENVIRON[p] || d[p]) {
191 continue;
192 }
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
209 }
210}')
211
212#-----------------------------------------------------------------
213%configure2_13 { \
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
224 --host=%{_target_platform} \
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
239 %{dependencytracking} \
240}
241
242%cmake { \
243CC="%{__cc}" \
244CXX="%{__cxx}" \
245CFLAGS="%{rpmcflags}" \
246CXXFLAGS="%{rpmcxxflags}" \
247LDFLAGS="%{rpmldflags}" \
248%{__cmake} \
249-DCMAKE_INSTALL_PREFIX=%{_prefix} \
250-DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \
251}
252
253%scons { \
254%{__scons} \
255 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
256 CFLAGS="${CFLAGS:-%rpmcflags}" \
257 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
258 FFLAGS="${FFLAGS:-%rpmcflags}" \
259 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
260 %{?__cc:CC="%{__cc}"} \
261 %{?__cxx:CXX="%{__cxx}"} \
262 libsuffix=%{_lib} \
263 prefix=%{_prefix} \
264}
265
266# waf. see waf.spec
267%waf { \
268CC="%{__cc}" \
269CXX="%{__cxx}" \
270CPP="%{__cpp}" \
271CFLAGS="%{rpmcflags}" \
272CXXFLAGS="%{rpmcxxflags}" \
273%{__waf} \
274}
275
276#----------------------------------------------------------------
277#%configure_cache 0
278%configure_cache_file %{buildroot}.configure.cache
279
280%configure {./configure \
281 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
282 CFLAGS="${CFLAGS:-%rpmcflags}" \
283 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
284 FFLAGS="${FFLAGS:-%rpmcflags}" \
285 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
286 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
287 %{?__cc:CC="%{__cc}"} \
288 %{?__cxx:CXX="%{__cxx}"} \
289 --host=%{_target_platform} \
290 --build=%{_target_platform} \
291 --prefix=%{_prefix} \
292 --exec-prefix=%{_exec_prefix} \
293 --bindir=%{_bindir} \
294 --sbindir=%{_sbindir} \
295 --sysconfdir=%{_sysconfdir} \
296 --datadir=%{_datadir} \
297 --includedir=%{_includedir} \
298 --libdir=%{_libdir} \
299 --libexecdir=%{_libexecdir} \
300 --localstatedir=%{_localstatedir} \
301 --sharedstatedir=%{_sharedstatedir} \
302 --mandir=%{_mandir} \
303 --infodir=%{_infodir} \
304 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
305 %{dependencytracking} \
306 %{?configure_cache:--cache-file=%{configure_cache_file}} \
307}
308
309# Simple macros to simplify adding bconded options to configure scripts.
310# Each macro requires bcond name and accepts optional option name, if option
311# isn't specified bcond name is used as option name. Options returning
312# --with and --enable also allow third argument which will be added as value
313# ( --with-option=value or --enable-option=value ) in case or positive
314# condition, but won't be added otherwise ( nothing or just --disable-option ).
315
316# Requirements:
317# BuildRequires: rpmbuild(macros) >= 1.527
318
319# Usage example:
320# %{__enable bcond} - returns --enable-bcond iff build condition is set
321# %{__disable bcond option} - returns --enable-option iff bcond is not set
322# %{__enable_disable bcond option value} - returns --enable-option=value if
323# bcond is set, returns --disable-option otherwise
324
325# expand bconds to --enable-something and --disable-something
326%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
327%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
328%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
329
330# same as above, but condition inverted
331%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
332%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
333%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
334
335# expand bconds to --with-something and --without-something
336%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
337%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
338%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
339
340# same as above, but condition inverted
341%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
342%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
343%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
344
345#-----------------------------------------------------------------
346
347# overload to insert debuginfo package
348%prep \
349%if 0%{?_enable_debug_packages}\
350%{debug_package}\
351%endif\
352%%prep\
353%{nil}
354
355# Location of autoconf macros
356%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
357
358# Location of omf files
359%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
360
361# Location of pkgconfig files
362%_pkgconfigdir /usr/%{_lib}/pkgconfig
363# noarch pkgconfig files
364%_npkgconfigdir /usr/share/pkgconfig
365
366# Location of desktop files
367%_desktopdir /usr/share/applications
368%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
369
370# Location of pixmaps for applnk/desktop files
371%_pixmapsdir /usr/share/pixmaps
372
373# Location of themable icons for applnk/desktop files
374%_iconsdir /usr/share/icons
375
376# Location of fonts directories
377%_fontsdir /usr/share/fonts
378
379# Location of Gtk and associated libraries documentation
380%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
381
382# Location of KDE documentation
383%_kdedocdir %{_defaultdocdir}/kde/HTML
384
385# unsermake script
386%__unsermake /usr/share/unsermake/unsermake
387
388# Current date
389%date %(LC_ALL=C date +"%a %b %d %Y")
390
391# Example files, programs, scripts...
392%_examplesdir /usr/src/examples
393
394# Alternative kernel type/version
395%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
396
397# The directory holding Linux kernel sources
398%_kernelsrcdir /usr/src/linux%{_alt_kernel}
399
400# SysV-style initscripts dir
401%_initddir /etc/rc.d/init.d
402
403# If non-empty "debug" macro defined, add "dbg" suffix to release number
404%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
405
406# Bootstrap release macros.
407# Usage:
408# %bcond_with bootstrap
409# Release: %{bootstrap_release 1}
410#
411# Package will have release 1 if built normally,
412# and release 0.zzz.bootstrap if built with bootstrap
413%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
414
415# -n drm to generate kernel%{_alt_kernel}-drm dependency
416%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
417%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
418%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
419
420# -s post to generate Requires(post) dependency
421%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
422%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
423%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
424
425# Requires name = version-release
426%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
427# Requires: name = version
428%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
429# Requires: name = version (version based on querying package %2)
430%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
431
432# Requires: name >= version
433%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
434# Requires: name >= version (version based on querying package %2)
435%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
436
437%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
438
439# kernel version-release handling
440%__kernel_ver %{expand:%%global __kernel_ver %( \\
441 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
442 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
443 echo ${Z:-ERROR}; \\
444)}%__kernel_ver
445
446%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
447%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
448%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
449%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
450
451# `uname -r` to be used in @release field
452%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
453
454# sgml macros
455%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
456%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
457%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
458%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
459%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
460%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
461%docbook_sgmlcat_fix() { for l in \
462'' \
463' -- default decl --' \
464'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
465' -- hacks for opensp --' \
466'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
467'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
468'' \
469; do echo $l; done >> %1 \
470}
471
472# vim - "
473
474# minimum file size needed for compressed documents.
475# just smaller files than this get larger when compressed.
476# some stats:
477# - 0 byte file compressed was 25 bytes .gz
478# - 39 byte file was compressed as 57
479# - with test/test.spec@man 158 byte file was compressed also 158
480%_min_compress_bytes 159
481
482#-----------------------------------------------------------------
483# find and gzip all files in %{_mandir} and %{infodir}
484#
485# Requires: xargs, find
486#
487#%no_install_post_compress_docs 1
488%__spec_install_post_compress_docs { \
489%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
490 for i in /usr/share/man /usr/X11R6/man; do \
491 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
492 echo "Compress man pages: $i"; \
493 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
494 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
495 find $RPM_BUILD_ROOT$i -type l | while read a; do \
496 m=$(readlink $a); \
497 rm -f $a; \
498 echo .so ${m##*/} > $a; \
499 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
500 done; \
501 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
502 fi; \
503 done; \
504 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
505 echo "Compress info pages: %{_infodir}"; \
506 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
507 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
508 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
509 fi; \
510}; __spec_install_post_compress_docs } }
511
512#-----------------------------------------------------------------
513# Strip executable binaries and shared object files
514#
515# Requires: find, awk, strip, cut, xargs
516#
517# Special macros which affect this process:
518#%no_install_post_strip 1 # disable stripping at all
519#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
520#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
521#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
522#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
523#
524%__spec_install_post_strip {%{!?debug: \
525%{!?no_install_post_strip:__spec_install_post_strip() { \
526if [ -d "$RPM_BUILD_ROOT" ]; then \
527 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
528 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
529 if [ "$modulelist" ]; then \
530 modulecount=$(echo "$modulelist" | wc -l); \
531 printf "Stripping %d kernel modules..." $modulecount; \
532 echo "$modulelist" | xargs -l512 chmod u+w; \
533 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
534 echo "DONE"; \
535 fi; \
536 fi; \
537 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
538 if [ -n "$filelist" ]; then \
539 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
540 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
541 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
542 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
543 if [ -n "$elfexelist" ]; then \
544 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
545 chmod u+w $elfexelist; \
546 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
547 echo "DONE"; \
548 fi; \
549 if [ -n "$elfsharedlist" ]; then \
550 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
551 chmod u+w $elfsharedlist; \
552 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
553 echo "DONE"; \
554 fi; \
555 if [ -n "$archiveslist" ]; then \
556 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
557 chmod u+w $archiveslist; \
558 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
559 echo "DONE"; \
560 fi; \
561 fi; \
562 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
563 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
564 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
565 if [ -n "$filelist_all" ]; then \
566 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
567 chmod u+w $filelist_all; \
568 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
569 echo "DONE"; \
570 fi; \
571 if [ -n "$filelist_unneeded" ]; then \
572 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
573 chmod u+w $filelist_unneeded; \
574 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
575 echo "DONE"; \
576 fi; \
577 if [ -n "$filelist_debug" ]; then \
578 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
579 chmod u+w $filelist_debug; \
580 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
581 echo "DONE"; \
582 fi; \
583fi; }; __spec_install_post_strip } } }
584
585#-----------------------------------------------------------------
586# remove all RPATH from executable binaries and shared object files
587#
588# Requires: find, awk, cut, xargs, chrpath, uname
589#
590# Special macros which affect this process
591#%no_install_post_chrpath 1 # disable chrpath at all
592#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
593#
594%__spec_install_post_chrpath {%{!?debug: \
595%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
596if [ -d "$RPM_BUILD_ROOT" ]; then \
597 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
598 if [ -n "$files" ]; then \
599 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
600 fi; \
601 if [ -n "$objs" ]; then \
602 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
603 echo "$objs" | \
604 while read file; do \
605 rpath= ; \
606 chmod u+w "$file"; \
607 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
608 case $dir in \
609 '$ORIGIN' ) \
610 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
611 else rpath="$rpath:$dir" ; fi ; \
612 continue ; \
613 ;; \
614 esac ; \
615 newdir=$(readlink -m "$dir"); \
616 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
617 case $dir in \
618 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
619 echo "remove-rpath: $dir in $file"; \
620 ;; \
621 * ) \
622 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
623 else rpath="$rpath:$dir" ; fi ; \
624 ;; \
625 esac ; \
626 done ; \
627 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
628 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
629 done; \
630 fi; \
631fi; }; __spec_install_post_chrpath } } }
632
633# vim: "
634
635#-----------------------------------------------------------------
636# Find all shared object files with unresolved symbols. Warn
637# and terminate if any found (termination can be turned off by define).
638#%no_install_post_check_so 1
639%__spec_install_post_check_so { \
640 __spec_install_post_check_so() { \
641 fail=0; \
642 printf "Searching for shared objects with unresolved symbols..."; \
643 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
644 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
645 done ; \
646 echo " DONE"; \
647 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
648}; __spec_install_post_check_so }}
649
650#-----------------------------------------------------------------
651# Find and gzip all kernel modules
652#
653# Requires: find
654#
655#%no_install_post_compress_modules 1
656%__spec_install_post_compress_modules { \
657%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
658 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
659 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
660 if [ "$q" ]; then \
661 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
662 echo "$q" | xargs -r %{__gzip} -9nf; \
663 echo "DONE"; \
664 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
665 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
666 fi; \
667 fi; \
668}; __spec_install_post_compress_modules } }
669
670# Remove common Perl files we don't package
671%__spec_install_post_perl_clean {\
672%{!?no_install_post_perl_clean: \
673%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
674} }
675
676#-----------------------------------------------------------------
677# Update GConf2 schemas
678#
679# Requires: GConf2
680#
681%gconf_schema_install() \
682 umask 022; \
683 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
684 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
685%{nil}
686
687%gconf_schema_uninstall() \
688if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
689 umask 022; \
690 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
691 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
692fi; \
693%{nil}
694
695#-----------------------------------------------------------------
696# Update desktop MIME database
697# requires: desktop-file-utils
698%update_desktop_database() {{ \
699 umask 022; \
700 /usr/bin/update-desktop-database -q; \
701};} \
702%{nil}
703
704%update_desktop_database_post %update_desktop_database
705
706%update_desktop_database_postun() {{ \
707if [ "$1" = "0" ]; then \
708 %update_desktop_database \
709fi; \
710};} \
711%{nil}
712
713#-----------------------------------------------------------------
714# Update shared MIME info database
715# requires: shared-mime-info
716#
717%update_mime_database() {{ \
718 umask 022; \
719 /usr/bin/update-mime-database %{_datadir}/mime; \
720};} \
721%{nil}
722
723#-----------------------------------------------------------------
724# Update icon cache
725# requires: gtk+
726#
727%update_icon_cache() {{ \
728 umask 022; \
729 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
730};} \
731%{nil}
732
733#-----------------------------------------------------------------
734# Update scrollkeeper database
735# requires: scrollkeeper
736#
737%scrollkeeper_update_post() \
738 /usr/bin/scrollkeeper-update -q; \
739%{nil}
740
741%scrollkeeper_update_postun() \
742if [ "$1" = "0" ]; then \
743 /usr/bin/scrollkeeper-update -q; \
744fi; \
745%{nil}
746
747#-----------------------------------------------------------------
748# post %install sequence:
749# - autodeps exceptions
750# - compress all man and info pages,
751# - strip all ELF executables and ELF shared objects if not %debug.
752# - compress kernel modules if any
753
754###################################################################
755# Requires/Provides automation
756# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
757#
758%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
759%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
760%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
761%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
762%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
763
764#%_noautocompressdoc %{nil}
765#
766%_missing_doc_files_terminate_build 1%{nil}
767%_unpackaged_files_terminate_build %{nil}
768# (X)emacs support
769%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
770%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
771%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
772
773%__php_provides %{nil}
774%__php_requires %{nil}
775%__perl_provides %{nil}
776%__perl_requires %{nil}
777%__mono_provides %{nil}
778%__mono_requires %{nil}
779
780# Perl specific macro definitions.
781%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
782%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
783%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
784%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
785%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
786%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
787
788# Ruby
789%__ruby /usr/bin/ruby
790%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
791%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
792%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
793%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
794%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
795%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
796%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
797%ruby_rdocdir /usr/share/rdoc
798%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
799%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
800%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
801
802%php_pear_dir /usr/share/pear
803%php_data_dir /usr/share/php
804%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
805%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
806%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
807
808# extract php/zend api versions
809%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
810%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
811%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
812%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
813%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
814%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
815%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
816%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
817
818# helper macro
819%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
820
821# macros for public use
822# for php extensions (php-pecl)
823%requires_php_extension %{__php_api_requires modules_api php_api_version} \
824%{__php_api_requires zend_module_api} \
825%{__php_api_requires -v %php_major_version debug php_debug} \
826%{__php_api_requires -v %php_major_version thread-safety zend_zts}
827
828# for zend extensions
829%requires_zend_extension %{__php_api_requires zend_module_api} \
830%{__php_api_requires zend_extension_api} \
831%{__php_api_requires -v %php_major_version debug php_debug} \
832%{__php_api_requires -v %php_major_version thread-safety zend_zts}
833
834# for php pdo modules (php-pecl-PDO_*)
835%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
836
837# for using PHP post scripts. for PHP >= 5.0
838%php_webserver_restart \
839[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
840[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
841if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
842 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
843 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
844 %service -q php-fcgi restart \
845 fi \
846fi \
847if [ -x /etc/rc.d/init.d/php-fpm ]; then \
848 %service -q php-fpm restart \
849fi \
850%{nil}
851
852# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
853%php4_webserver_restart \
854[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
855[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
856if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
857 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
858 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
859 %service -q php-fcgi restart \
860 fi \
861fi \
862%{nil}
863
864# X.org helper macros
865%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
866%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
867
868%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
869%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
870%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
871%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
872%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
873# vim: '
874
875%requires_xorg_xserver_extension \
876%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
877%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
878%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
879%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
880%{nil}
881
882%requires_xorg_xserver_xinput \
883%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
884%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
885%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
886%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
887%{nil}
888
889%requires_xorg_xserver_font \
890%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
891%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
892%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
893%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
894%{nil}
895
896%requires_xorg_xserver_videodrv \
897%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
898%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
899%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
900%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
901%{nil}
902
903# TCL specific macro definitions.
904# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
905%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
906%tcl_sitearch %{_libdir}/tcl%{tcl_version}
907%tcl_sitelib %{_datadir}/tcl%{tcl_version}
908
909# Python specific macro definitions.
910# python main version
911%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
912
913# directories
914%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
915%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
916%py_scriptdir %{py_prefix}/share/python%{py_ver}
917%py_incdir /usr/include/python%{py_ver}
918%py_sitedir %{py_libdir}/site-packages
919%py_sitescriptdir %{py_scriptdir}/site-packages
920%py_dyndir %{py_libdir}/lib-dynload
921
922# pure python modules compilation
923%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
924
925%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
926
927# Software written in Python language require Python with main version
928%pyrequires_eq() Requires: %1
929
930# Python 3.x
931# python main version
932%__python3 python3
933%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
934
935# directories
936%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
937%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
938%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
939%py3_incdir /usr/include/python%{py3_ver}
940%py3_sitedir %{py3_libdir}/site-packages
941%py3_sitescriptdir %{py3_scriptdir}/site-packages
942%py3_dyndir %{py3_libdir}/lib-dynload
943
944# pure python modules compilation
945%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
946
947%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
948
949# Hardlink binary identical .pyc and .pyo files
950%__spec_install_post_py_hardlink {\
951%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
952local a b c=0 t=0; \
953if [ -d "$RPM_BUILD_ROOT" ]; then \
954 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
955 while read a; do \
956 b="${a%.pyc}.pyo"; \
957 if cmp -s "$a" "$b"; then \
958 ln -f "$a" "$b"; \
959 c=$((c + 1)); \
960 fi; \
961 t=$((t + 1)); \
962 done < __rpm_pyc; \
963 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
964 rm -f __rpm_pyc; \
965fi; \
966}; __spec_install_post_py_hardlink } }
967
968# remove python sources, so that check-files won't complain
969%py_postclean() \
970for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
971 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
972done \
973%{nil}
974
975%py3_postclean() \
976for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
977 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
978done \
979%{nil}
980
981# depmod macro
982%depmod() { \
983umask 022; \
984if [ -e /boot/System.map-%1 ]; then \
985 /sbin/depmod -a -F /boot/System.map-%1 %1; \
986else \
987 if [ -e /boot/System.map ]; then \
988 /sbin/depmod -a -F /boot/System.map %1; \
989 else \
990 /sbin/depmod -a %1; \
991 fi \
992fi; \
993}
994
995# XMMS specific macros
996%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
997%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
998%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
999%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1000%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1001%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1002%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1003%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1004%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1005%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1006
1007%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1008
1009# user/group checking macros
1010#
1011# Usage:
1012# %userremove myuser
1013#
1014%userremove /usr/lib/rpm/user_group.sh user del
1015%groupremove /usr/lib/rpm/user_group.sh group del
1016#
1017# Usage:
1018# if %usertestrm myuser; then
1019# /usr/sbin/userdel -r myuser
1020# Note:
1021# use these macros only if you need to call userdel/groupdel with
1022# a non-standard option or take an extra action; otherwise use the
1023# %userremove/%groupremove macros
1024#
1025%usertestrm /usr/lib/rpm/user_group.sh user testrm
1026%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1027# user group membership management macros
1028#
1029# Usage:
1030# %addusertogroup [-q] myuser agroup
1031#
1032# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1033#
1034# Requirements:
1035# BuildRequires: rpmbuild(macros) >= 1.515
1036%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1037%{nil}
1038
1039# banner support (useful in {pre,post}{,un} and triggers)
1040#
1041# Usage:
1042# %banner name [-a] [-e] [-n] [-tn] <<EOF
1043# the banner text, the banner text
1044# the banner text, and following line
1045#EOF
1046# You can use any form of here-document, <<'EOF' <<-EOT will do.
1047# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1048#
1049# -a - append to the banner
1050# -e - send to stderr instead of stdout
1051# -n - no show banner (overrides -t)
1052# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1053#
1054# Tests:
1055# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1056# rpm -E 'date | %banner -e banner' > m; sh -x m
1057#
1058%banner(aent:) ( \
1059RPM_SCRIPTVERBOSITY=5 \
1060[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1061if [ -x /usr/bin/banner.sh ]; then \
1062 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1063else \
1064 CMD="cat%{-e: >&2}" \
1065fi \
1066eval $CMD %{?2:%2}%{?3: %3}) \
1067%{nil}
1068
1069# useradd/groupadd macros
1070# Author: Elan Ruusamäe <glen@pld-linux.org>
1071#
1072# Usage:
1073# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1074# [-g initial_group] [-G group[,...]] login
1075#
1076# -u uid. REQUIRED
1077# -g gid/group. REQUIRED
1078# -s defaults to /bin/false
1079# -d defaults to /usr/share/empty
1080# -c No default
1081# -r is accepted but ignored (it's always set)
1082# -k skeleton dir. defaults to /usr/share/empty
1083# rpm specific flags
1084# -P package name. defaults to %{name}
1085#
1086%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1087%{!-u:%{error:useradd: Required argument -u missing}} \
1088%{!-g:%{error:useradd: Required argument -g missing}} \
1089%{!?1:%{error:useradd: Required parameter login missing}} \
1090if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1091 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1092 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1093 exit 1 \
1094 fi \
1095else \
1096 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1097 /usr/sbin/useradd \\\
1098 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1099 -u %{-u*} \\\
1100 -r \\\
1101 -d %{-d*}%{!-d:/usr/share/empty} \\\
1102 -s %{-s*}%{!-s:/bin/false} \\\
1103 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1104 -g %{-g*} \\\
1105 %{-M} \\\
1106 %{-G:-G %{-G*}} \\\
1107 %{expand:%{%{#}}} 1>&2 || exit $? \
1108 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1109fi;
1110# vim: "
1111
1112# Usage:
1113# %groupadd [-P package] [-g gid] group
1114#
1115# -g gid. REQUIRED
1116#
1117# Sample:
1118# %groupadd -P %{name}-base -g %{gid} %{name}
1119
1120%groupadd(g:P:rfo) \
1121%{!-g:%{error:groupadd: Required argument -g missing}} \
1122%{!?1:%{error:groupadd: Required parameter group missing}} \
1123if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1124 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1125 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1126 exit 1 \
1127 fi \
1128else \
1129 echo "Adding group %{1} GID=%{-g*}." \
1130 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1131 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1132fi;
1133
1134# webapp macros
1135# Author: Elan Ruusamäe <glen@pld-linux.org>
1136#
1137# The config is installed/removed inside trigger, this means that you can any
1138# time install apache1/apache/lighttpd package and the configuration file is
1139# updated. if you don't need the config for various reason for specific
1140# webserver, just remove the symlink from config directory using webapp
1141# program. the trigger will not recreate the symlink on upgrades. In other
1142# words the config is linked to webserver config directory on first install of
1143# PACKAGE or WEBSERVER.
1144#
1145# Add package's webserver config to webserver webapps dir.
1146# Usage:
1147# %webapp_register [-f] WEBSERVER WEBAPP
1148#
1149%webapp_register(f) \
1150%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1151if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1152 /usr/sbin/webapp register %1 %2\
1153fi\
1154# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1155if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1156 %{expand:%service -q %%1 reload}\
1157fi\
1158%{nil}
1159
1160# Remove package's config from webserver webapps dir.
1161# Usage:
1162# %webapp_register [-f] WEBSERVER WEBAPP
1163%webapp_unregister(f) \
1164%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1165# remove link if either of the packages are gone \
1166if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1167 /usr/sbin/webapp unregister %1 %2\
1168 %{expand:%service -q %%1 reload}\
1169fi \
1170%{nil}
1171
1172# service macro.
1173# Author: Elan Ruusamäe <glen@pld-linux.org>
1174#
1175# calls usual service restart on package %post, but skips the restart if
1176# administrator has disabled automatic service restarts in either global
1177# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1178#
1179# Usage:
1180# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1181#
1182# -q be silent when service isn't started (for scriplets restaring other package's services)
1183# -n NOOP mode, do not actually restart service
1184#
1185# Requirements:
1186# BuildRequires: rpmbuild(macros) >= 1.268
1187# Requires: rc-scripts
1188# -n option:
1189# BuildRequires: rpmbuild(macros) >= 1.450
1190%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1191
1192
1193# Java macros. based on jpackage macros.java
1194#
1195# Root directory where all Java VMs/SDK/JREs are installed.
1196%_jvmdir %{_libdir}/jvm
1197
1198# Root directory where all Java VMs/SDK/JREs expose their jars
1199%_jvmjardir %{_libdir}/jvm-exports
1200
1201# Root directory for all Java VM/SDK/JRE's private things.
1202%_jvmprivdir %{_libdir}/jvm-private
1203
1204# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1205%_jvmlibdir %{_libdir}/jvm
1206
1207# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1208%_jvmdatadir %{_datadir}/jvm
1209
1210# Root directory for all configurations parts of Java VM/SDK/JRE's
1211%_jvmsysconfdir %{_sysconfdir}/jvm
1212
1213# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1214%_jvmcommonlibdir %{_libdir}/jvm-common
1215
1216# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1217%_jvmcommondatadir %{_datadir}/jvm-common
1218
1219# Root directory for all common configurations parts of Java VM/SDK/JRE's
1220%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1221
1222# Directory where arch-specific (JNI) version-independent jars are installed.
1223%_jnidir %{_libdir}/java
1224
1225
1226# JDK selection. Set this to name of the JDK implementation to use
1227# insead of the system default
1228#%use_jdk icedtea6
1229
1230# expands to the value with right jdk for BuildRequires header
1231# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1232# The requirement will not replace current 'default' JDK
1233%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1234
1235%buildrequires_jdk BuildRequires: %required_jdk
1236
1237%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1238
1239%_javasrcdir %{_usrsrc}/java
1240
1241%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1242%jar %{java_home}/bin/jar
1243%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1244%javac %{java_home}/bin/javac
1245%javadoc %{java_home}/bin/javadoc
1246
1247%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1248
1249%jpackage_script() \
1250install -d $RPM_BUILD_ROOT%{_bindir}\
1251cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1252#!/bin/sh\
1253#\
1254# %{name} script\
1255# JPackage Project <http://www.jpackage.org/>\
1256\
1257# Source functions library\
1258. %{_javadir}-utils/java-functions\
1259\
1260# Source system prefs\
1261if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1262 . %{_sysconfdir}/java/%{name}.conf\
1263fi\
1264\
1265# Source user prefs\
1266if [ -f $HOME/.%{name}rc ]; then\
1267 . $HOME/.%{name}rc\
1268fi\
1269\
1270# Configuration\
1271MAIN_CLASS=%1\
1272BASE_FLAGS=%2\
1273BASE_OPTIONS=%3\
1274BASE_JARS="%(echo %4 | tr ':' ' ')"\
1275\
1276# Set parameters\
1277set_jvm\
1278set_classpath $BASE_JARS\
1279set_flags $BASE_FLAGS\
1280set_options $BASE_OPTIONS\
1281\
1282# Let's start\
1283run "$@"\
1284EOF
1285
1286# jpackage 1.7
1287# Directory for maven depmaps
1288#
1289%_mavendepmapdir /etc/maven
1290%_mavendepmapfragdir /etc/maven/fragments
1291
1292#
1293# add_to_depmap adds an entry to the depmap. The arguments are:
1294#
1295# %1 the original groupid
1296# %2 the original artifact id
1297# %3 the version
1298# %4 the new groupid
1299# %5 the new artifactid
1300#
1301
1302%add_to_maven_depmap() \
1303install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1304cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1305<dependency>\
1306 <maven>\
1307 <groupId>%1</groupId>\
1308 <artifactId>%2</artifactId>\
1309 <version>%3</version>\
1310 </maven>\
1311 <jpp>\
1312 <groupId>%4</groupId>\
1313 <artifactId>%5</artifactId>\
1314 <version>%3</version>\
1315 </jpp>\
1316</dependency>\
1317\
1318EOF\
1319%{nil}
1320
1321#==============================================================================
1322#
1323# update_maven_depmap updates the main maven depmap
1324#
1325%update_maven_depmap() \
1326echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1327if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1328cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1329fi\
1330echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1331
1332# JAVA macros specific for PLD
1333
1334# Directory for tomcat context configuration files
1335%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1336
1337# Tomcat cache path
1338%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1339
1340# Clear tomcat cache
1341# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1342#
1343# Usage:
1344# %%tomcat_clear_cache appname
1345#
1346# Call this script in %postun scriptlet. It will remove compiled jsps related to
1347# given app.
1348#
1349%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1350
1351# PEAR install macros
1352# Author: Elan Ruusamäe <glen@pld-linux.org>
1353#
1354# Usage:
1355# %%pear_package_setup ...
1356#
1357# -a # - also unpack SOURCE#. for PEAR bootstrapping
1358# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1359# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1360# -D - pass -D to %setup (so the build dir is not removed)
1361# -c - register channel from local channel.xml file
1362# -d - pass -d arg to pearcmd
1363#
1364# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1365# destination hierarchy. you should copy the tree to buildroot after
1366# patching/reorganizing with %%pear_package_install.
1367#
1368# additionally BUILDROOT is stripped from files and files are converted to UNIX
1369# line endings.
1370#
1371# the pear install process output is recorded to install.log, you should put it
1372# to %%doc for later debug or just for information.
1373#
1374# additionally additional-packages.txt is produced if it was detected that the
1375# package has optional dependencies. the file format is suitable of displaying
1376# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1377# automatically added for this file.
1378
1379
1380# records install.log and transforms PEAR names to PLD Linux rpm package names.
1381%__pear_install_log \
1382tee install.log \
1383# make post message of optional packages \
1384grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1385if [ -s optional-packages.txt ]; then \
1386 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1387else \
1388 rm -f optional-packages.txt \
1389fi \
1390%{nil}
1391
1392# Command invoking PEAR CLI
1393# Same as /usr/bin/pear, except we force GMT timezone
1394%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1395
1396%pear_install(a:d:n:zD) \
1397%__pear \\\
1398 -c %{builddir}/pearrc \\\
1399 -d doc_dir=/docs \\\
1400 -d temp_dir=/tmp \\\
1401 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1402 -d bin_dir=%{_bindir} \\\
1403 -d data_dir=%{php_pear_dir}/data \\\
1404 -d test_dir=%{php_pear_dir}/tests \\\
1405 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1406 install \\\
1407 --packagingroot=%{builddir} \\\
1408 --offline \\\
1409 --nodeps \\\
1410 %{-f:--force} \\\
1411 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1412 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1413%{nil}
1414
1415# The main macro.
1416# using this macro will append optional-packages.txt to the nocompressdoc list
1417# as it's displayed to user after package install. and adding additional gzip
1418# dep is just waste ;)
1419%pear_package_setup(a:d:n:zDc:) \
1420%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1421%define builddir %{_builddir}/%{srcdir} \
1422%setup -q -c -T %{-D:-D} -n %{srcdir} \
1423%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1424%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1425%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1426%pear_install \
1427%{-z:cd ..} \
1428cat %{-z:$_N/}.install.log | %__pear_install_log \
1429\
1430# undos sources \
1431find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1432%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1433%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1434%{nil}
1435
1436# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1437# Author: Elan Ruusamäe <glen@pld-linux.org>
1438%pear_package_install() \
1439cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1440find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1441# help the developer out a little: \
1442if [ -f _noautoreq ]; then \
1443 echo "AutoReqdep detected:" \
1444 echo "_noautoreq $(cat _noautoreq)" \
1445fi \
1446%{nil}
1447
1448# Print optional package info for pear packages
1449# Author: Elan Ruusamäe <glen@pld-linux.org>
1450# Usage:
1451# %post -p <lua>
1452# %%pear_package_print_optionalpackages
1453#
1454# Requirements:
1455# BuildRequires: rpmbuild(macros) >= 1.571
1456%pear_package_print_optionalpackages \
1457f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1458if f then \
1459 for l in f:lines() do print(l); end \
1460end \
1461%{nil}
1462
1463
1464# Register OpenLDAP schema.
1465# Author: Elan Ruusamäe <glen@pld-linux.org>
1466#
1467# Usage:
1468# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1469#
1470# -d specify dependant schemas, separated by comma
1471#
1472%openldap_schema_register(d:) \
1473for schema in %*; do \
1474 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1475 %{__sed} -i -e " \
1476 /^include.*local.schema/{ \
1477 iinclude\\t $schema\
1478 } \
1479 " /etc/openldap/slapd.conf \
1480 fi \
1481done \
1482# enable dependant schemas \
1483if [ "%{-d*}" ]; then \
1484 %{__sed} -i -e ' \
1485 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1486 s/^#// \
1487 }' /etc/openldap/slapd.conf \
1488fi \
1489%{nil}
1490
1491# Unregister OpenLDAP schema.
1492# Author: Elan Ruusamäe <glen@pld-linux.org>
1493#
1494# Usage:
1495# %%openldap_schema_unregister %{schemadir}/horde.schema
1496#
1497%openldap_schema_unregister() \
1498for schema in %*; do \
1499 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1500 %{__sed} -i -e " \
1501 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1502 # for symmetry it would be nice if we disable enabled schemas in post, \
1503 # but we really can not do that, it would break something else. \
1504 " /etc/openldap/slapd.conf \
1505 fi \
1506done \
1507%{nil}
1508
1509%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1510
1511
1512# Build modules for kernels 2.6
1513# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1514#
1515# Usage:
1516# %build_kernel_modules -m <modules> -C <directory>
1517#
1518# remember that proper Makefile is still required
1519# Options:
1520# -m <modules> (required) -- comma-separated list of modules to save,
1521# without .ko extension, may be placed in subdirectory
1522# -C <directory> -- change to <directory> before doing anything
1523# -p <arg>, -P <arg> -- arguments passeed to make scripts
1524# -c -- do not execute make clean
1525# <additional arguments> -- all additional arguments will be passed to
1526# make modules
1527#
1528# Additional patching supported via here document. Try:
1529# %build_kernel_modules -m module <<'EOF'
1530# your patch script here
1531# EOF
1532# Don't use it unless patching depends on config options.
1533
1534# Developer note: don't touch it unless you know how to handle '\'.
1535# - \ in script expands to nothing
1536# - \\\ in script expands to \
1537# - \\\ inside definition expands to nothing
1538# - \\\\\\\ inside definition expands to \
1539# - in last line \ has to touch arguments so arguments passing
1540# in new lines (using \) will be supported
1541
1542%build_kernel_modules(p:P:m:C:c) \
1543%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1544 \
1545%define Opts \\\\\\\
1546%if "%{_target_base_arch}" != "%{_arch}" \\\
1547 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1548 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1549 %else \\\
1550 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1551 %endif \\\
1552%else \\\
1553 CC="%{kgcc}" \\\
1554%endif \
1555%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1556 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1557 \
1558%{?-C:cd %{-C*}} \
1559compile() { \
1560 local L="<" PATCH_SH; \
1561 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1562 set -e -x \
1563 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1564 \
1565for cfg in ${cfgs:-dist}; do \
1566 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1567 \
1568 rm -rf o \
1569 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1570 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1571 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1572 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1573 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1574 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1575 else \
1576 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1577 fi \
1578 \
1579 set +x \
1580 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1581 set -x \
1582 \
1583 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1584 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1585 %{-p*} %{-P*} \\\
1586 %{MakeOpts} \
1587 %else \
1588 install -d o/include/config \
1589 touch o/include/config/MARKER \
1590 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1591 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1592 %endif \
1593 \
1594 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1595 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1596 ${1+"$@"} \\\
1597 M=$PWD %{MakeOpts}} \
1598 \
1599 %{__make} -C %{_kernelsrcdir} modules \\\
1600 ${1+"$@"} \\\
1601 M=$PWD %{MakeOpts} \
1602 \
1603 for MODULE in {%{-m*},}; do \
1604 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1605 done \
1606done \
1607%{?-C:cd -} \
1608} \
1609compile %{*}\
1610%{nil}
1611
1612
1613# Install kernel modules built by %build_kernel_modules
1614# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1615#
1616# Usage:
1617# %install_kernel_modules -m <modules> -d <directory>
1618#
1619# Options:
1620# -m <modules> (required) -- comma-separated list of modules to install,
1621# without .ko extension, may be placed in subdirectory
1622# -d <directory> (required) -- in what subdirectory modules should be
1623# installed (eg. misc, kernel/drivers/net)
1624# -s <suffix> -- suffix to use when installing modules, useful when module
1625# with same name exists in kernel already
1626# -n <file> -- name of modprobe config file to use (without .conf extension)
1627# for defining aliases, only useful with -s
1628
1629%install_kernel_modules(m:d:s:n:) \
1630%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1631%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1632%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1633 \
1634%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1635%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1636 \
1637__install_kernel_modules() { \
1638local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1639 \
1640for MODULE in {%{-m*},}; do \
1641 [ -n "${MODULE}" ] || continue \
1642 for cfg in ${cfgs:-dist}; do \
1643 [ "$cfg" = smp ] && suf=smp || suf= \
1644 MNAME=${MODULE##*/} \
1645 install -D ${MODULE}-$cfg.ko \\\
1646 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1647 %{?-s:install -d %{ModprobeD}$suf \
1648 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1649 >> %{ModprobeD}$suf/%{-n*}.conf} \
1650 done \
1651done \
1652} \
1653__install_kernel_modules \
1654%{nil}
1655
1656# patchset macros
1657# Author: Elan Ruusamäe <glen@pld-linux.org>
1658#
1659# Usage:
1660# %patchset_source -f <seq(1) format> <start> [<end>]
1661# %patchset_patch <start> [<end>]
1662#
1663# If <end> is omited, it is assumed to be <start>.
1664#
1665# For example in preamble:
1666# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1667# and in %prep:
1668# %patchset_patch 33 44
1669
1670# generate SourceX urls from range START STOP
1671# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1672# The sources start from 10000
1673%patchset_source(f:b:) %(
1674 base=%{-b*}%{!-b*:10000};
1675 start=$(expr $base + %1);
1676 end=$(expr $base + %{?2}%{!?2:%{1}});
1677 # we need to call seq twice as it doesn't allow two formats
1678 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1679 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1680 paste %{tmpdir}/__ps{1,2};
1681 rm -f %{tmpdir}/__ps{1,2};
1682) \
1683%{nil}
1684
1685# apply sources from %patchset_source
1686# -p specify -pX for %patch line
1687# -b base offset: defaults to 10000
1688%patchset_patch(f:p:b:) %(
1689 base=%{-b*}%{!-b*:10000};
1690 start=$(expr $base + %1);
1691 end=$(expr $base + %{?2}%{!?2:%{1}});
1692 echo ": patchset_patch %1%{?2: to %2}";
1693 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1694) \
1695%{nil}
1696
1697# browser plugins v2
1698# Author: Elan Ruusamäe <glen@pld-linux.org>
1699#
1700# Usage:
1701# %browser_plugins_add_browser <name> -p <plugindir>
1702#
1703# <name> (required) -- name of the browser. usually %{name}.
1704# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1705# -b -- default blacklists
1706# -a <arch> override arch
1707#
1708# Example:
1709# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1710
1711%_browserpluginsconfdir /etc/browser-plugins
1712%_browserpluginsdir %{_libdir}/browser-plugins
1713%update_browser_plugins /usr/sbin/update-browser-plugins || :
1714
1715%browser_plugins_add_browser(p:b:a:) \
1716 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1717 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1718 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1719 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1720 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1721 %{-b:cat >> $blacklist_file %{-b*}} \
1722%{nil}
1723
1724# Helper for LUA.
1725# split string separated by space into quoted list
1726#
1727# Author: Elan Ruusamäe <glen@pld-linux.org>
1728#
1729# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1730%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1731
1732# adjust /etc/shells by adding and removing shells from there
1733# Author: Elan Ruusamäe <glen@pld-linux.org>
1734#
1735# Usage:
1736# %post -p <lua>
1737# %lua_add_etc_shells /bin/sh /bin/pdksh
1738#
1739# %preun -p <lua>
1740# if arg[2] == 0 then
1741# %lua_remove_etc_shells /bin/bash /bin/rbash
1742# end
1743#
1744# Requirements:
1745# BuildRequires: rpmbuild(macros) >= 1.462
1746#
1747
1748%lua_add_etc_shells() \
1749t = {}\
1750f = io.open("/etc/shells", "r")\
1751if f then\
1752 for l in f:lines() do t[l]=l; end\
1753 f:close()\
1754end\
1755for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1756 if not t[s] then\
1757 print("Adding "..s.." to /etc/shells")\
1758 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1759 end\
1760end\
1761%{nil}
1762
1763%lua_remove_etc_shells() \
1764t = {}\
1765f = io.open("/etc/shells", "r")\
1766if f then\
1767 for l in f:lines() do t[l]=l; end\
1768 f:close()\
1769end\
1770for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1771 print("Removing "..l.." from /etc/shells")\
1772 t[l] = nil\
1773end\
1774s=""\
1775for _, l in pairs(t) do\
1776 s=s..l.."\\n"\
1777end\
1778io.open("/etc/shells", "w"):write(s)\
1779%{nil}
1780
1781# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1782#
1783# Author: Elan Ruusamäe <glen@pld-linux.org>
1784#
1785# Usage:
1786# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1787# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1788#
1789# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1790#
1791# Requirements:
1792# BuildRequires: rpmbuild(macros) >= 1.429
1793#
1794%add_etc_shells(p) %{-p:<lua>}\
1795%{expand:%%lua_add_etc_shells %*}\
1796%{nil}
1797
1798%remove_etc_shells(p) %{-p:<lua>}\
1799%{-p:if arg[2] == 0 then}\
1800%{expand:%%lua_remove_etc_shells %*}\
1801%{-p:end} \
1802%{nil}
1803
1804# Check syntax for Python files
1805#
1806# Author: Elan Ruusamäe <glen@pld-linux.org>
1807# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1808#
1809# Usage:
1810# %py_lint src
1811#
1812# Requirements:
1813# BuildRequires: python
1814# BuildRequires: rpmbuild(macros) >= 1.469
1815
1816%py_lint() \
1817__py_lint() { \
1818find "$@" -type f -name '*.py' | python -c ' \
1819import sys \
1820import compiler \
1821\
1822err = 0\
1823for f in sys.stdin: \
1824 fd = open(f.strip()) \
1825 c = fd.read() \
1826 fd.close() \
1827 try: \
1828 compiler.parse(c) \
1829 except SyntaxError, e: \
1830 print "py_lint: %s: %s" % (f.strip(), e) \
1831 err = err + 1\
1832\
1833if err: \
1834 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1835 sys.exit(1) \
1836else: \
1837 print >> sys.stderr, "py_lint: Found no syntax errors." \
1838' \
1839}; __py_lint %* \
1840%{nil}
1841
1842# Undos files
1843#
1844# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1845# Author: Elan Ruusamäe <glen@pld-linux.org>
1846#
1847# Usage:
1848# %undos list_of_files
1849# %undos -f EXT[,EXT]
1850# %undos -i -f EXT[,EXT]
1851#
1852# -f EXT[,EXT] - find(1) files by extensions
1853# -i - case insensitive file search
1854#
1855# Example:
1856# Un-DOS all *.js, *.css files
1857# %undos -f js,css
1858# Un-DOS all *.js, *.JS files
1859# %undos -f js -i
1860# undos all Makefiles
1861# %{__find} -name Makefile | xargs %undos
1862#
1863# Requirements:
1864# BuildRequires: sed >= 4.0
1865# BuildRequires: rpmbuild(macros) >= 1.565
1866
1867# NB: make sure this macro stays on one line
1868# NB: make sure it includes newline escape
1869%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1870%{nil}
1871
1872# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1873#
1874# Author: Elan Ruusamäe <glen@pld-linux.org>
1875#
1876# Usage:
1877# -a NAME -- add command named NAME
1878# -d NAME -- remove command named NAME
1879# -f FILE -- specify plugin configuration FILE to extract command definition from
1880#
1881# Sample:
1882# %triggerin -- nagios-nrpe
1883# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1884#
1885# %triggerun -- nagios-nrpe
1886# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1887#
1888# Requirements:
1889# Requires: grep
1890# Requires: sed >= 4.0
1891# BuildRequires: rpmbuild(macros) >= 1.552
1892%nagios_nrpe(a:d:c:f:) {\
1893 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1894 %{-a:# on -a and config exists \
1895 if [ -f /etc/nagios/nrpe.cfg ]; then \
1896 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1897 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1898 fi; \
1899 fi;} \
1900 %{-d:# on package remove, -d and config exists \
1901 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1902 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1903 fi;} \
1904 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1905 %service -q nrpe restart; \
1906 fi; \
1907}%{nil}
1908
1909# Import or update Cacti template.
1910#
1911# Author: Elan Ruusamäe <glen@pld-linux.org>
1912#
1913# Usage:
1914# %cacti_import_template XMLFILE
1915# XMLFILE -- XML template to import
1916#
1917# Sample:
1918# %post
1919# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1920#
1921# Requires: cacti >= 0.8.7e-8
1922# BuildRequires: rpmbuild(macros) >= 1.554
1923
1924%cacti_import_template() {\
1925/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1926}%{nil}
1927
1928# pre/post script for -upstart subpackages
1929#
1930# Author: Jacek Konieczny <jajcus@jajcus.net>
1931#
1932# Usage:
1933# %upstart_post service_name
1934# %upstart_postun service_name
1935#
1936# Sample:
1937# %post upstart
1938# %upstart_post %{name}
1939#
1940# %postun upstart
1941# %upstart_postun %{name}
1942#
1943# Requirements:
1944# BuildRequires: rpmbuild(macros) >= 1.560
1945# Requires: rc-scripts >= 0.4.3
1946
1947# migrate from init script to upstart job
1948%upstart_post() \
1949 if [ -f /var/lock/subsys/"%1" ] ; then \
1950 /sbin/service --no-upstart "%1" stop \
1951 /sbin/service "%1" start \
1952 fi
1953
1954# restart the job after upgrade or migrate to init script on removal
1955# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1956# at this point
1957%upstart_postun() \
1958 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1959 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1960 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1961 fi
1962
1963# vim:ts=4 sw=4 noet ft=spec
This page took 0.284694 seconds and 4 git commands to generate.